/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#ifndef CACHINGCONTROLLER_H
#define CACHINGCONTROLLER_H

#include "Controller.h"
#include <memory.h>

/** An abstract controller that caches its input. This may be useful when the output(t)
depens on both input(t) and input (t-dt). */

class CachingController : public Controller  {
public:
	CachingController(unsigned int nInputs, unsigned int nOutputs);
	virtual ~CachingController();

protected:
	float* oldInput;

	/** Copies input to oldInput. */
	void cacheInput(){
		memcpy(oldInput,input,sizeof(float)*nInputs);
	}

};

#endif //CACHINGCONTROLLER_H
