/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#include "RandomController.h"
#include "Random.h"

RandomController::RandomController(unsigned int nInputs, unsigned int nOutputs, unsigned int randSeed):
	Controller(nInputs, nOutputs){
		Random::setSeed(randSeed);
		unsigned int i;
		for(i=0;i<nOutputs;i++)
			output[i]=Random::getFloat();
}

RandomController::~RandomController(){

}

void RandomController::advanceTime(){
	unsigned int i;
	for(i=0;i<nOutputs;i++){
		output[i]+=(Random::getFloat()-0.5f)/10.0f;
		if(output[i]<0.0) output[i]=0.0;
		if(output[i]>1.0) output[i]=1.0;
	}

}