/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#if !defined(AFX_GRAPH_H__6AA46D96_39C9_4C8F_9FCC_3446AE0C8C94__INCLUDED_)
#define AFX_GRAPH_H__6AA46D96_39C9_4C8F_9FCC_3446AE0C8C94__INCLUDED_

#include "GraphData.h"
#include <wx/dcmemory.h>

/** This class manages the drawing of a graphic of the evolution in time of one or more quantities. */
class Graph  {
public:
	Graph(int width, int height, int bufferSize, int nSubGraphs=1, float min=0, float max=1);
	virtual ~Graph();

	/** The dimensions, in pixels, of the graphical area on which the graph is drawn. */
	int width, height;
	float min, max;	
	
	/** The size of the memory buffer of the graph  */
	int bufferSize;

	/** The composing subgraph. More than one subgraph (curves) can be displayed in the same graph. */
	GraphData** subGraphs;
	int nSubGraphs;

	/** Adds a data value to the specified subgraph. */
	void push(float value, int nSubGraph=0);

	/** Bitmap used for internal buffer. */
	wxBitmap bitmap;
	/** DC used for internal buffer. */
	wxMemoryDC dc;

	void drawBuffer();
	void draw(wxDC* outdc, int x, int y);



};

#endif // !defined(AFX_GRAPH_H__6AA46D96_39C9_4C8F_9FCC_3446AE0C8C94__INCLUDED_)
