/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// Pac.h: interface for the Pac class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PAC_H__65EEAA15_5429_4476_885F_AF955C54055A__INCLUDED_)
#define AFX_PAC_H__65EEAA15_5429_4476_885F_AF955C54055A__INCLUDED_

#include "Elastoid.h"
#include "RandomController.h"

class Pac : public Elastoid  {
public:
	Pac(real x0, real y0);
	virtual ~Pac();

	/** The link that can be controlled by the agent (the mouth). */
	ElasticLink* activeLink;

	/** The rest length of the active link. */
	real l;


	RandomController controller;

	virtual void controll();
	
private:
	/** The number of circles that compose the agent. Should be odd. */
	int nCircles;

	/** The radius of the circular structure of the agent. */
	real rPac;

	real u0, u;

	int index(int i){
		if(i<0) return i+nCircles; else return i;
	}
	

};

#endif // !defined(AFX_PAC_H__65EEAA15_5429_4476_885F_AF955C54055A__INCLUDED_)
