/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#include "SpherusSimulator.h"
#include "Spherus.h"
#include "Border.h"
#include "Circle.h"
#include "CappedRectangle.h"

SpherusSimulator::SpherusSimulator() {
	real width=6, height=4;
	//set the borders of the simulator space
	registerObject(new Border(0, height/2, 1, 0, "left border"));
	registerObject(new Border(width, height/2, -1, 0, "right border"));
	registerObject(new Border(width/2, 0,	0, 1, "bottom border"));
	registerObject(new Border(width/2, height, 0,  -1, "upper border"));
	
	/** r, x, y. */
	float circles[6][3] = {
		{0.1f, 5.0f, 3.0f},
		{0.2f, 0.4f, 0.6f},
		{0.1f, 0.8f, 0.9f},
		{0.2f, 1.7f, 2.8f},
		{0.25f, 4.7f, 2.5f},
		{0.1f, 3.5f, 1.0f}
	};

	//add the agent
	agent=new Spherus(2.5f, 1.5f);
	registerObject(agent);


	//add balls
    for (unsigned i = 0; i < 6; ++i) {
        Circle *circle = 
            new Circle(circles[i][0], circles[i][1], circles[i][2]);
        registerObject(circle);
    }

	registerObject(new CappedRectangle(0.3f,  0.1f, 3.0f, 2.2f, 10*degrees, "capsule 1"));
}

SpherusSimulator::~SpherusSimulator(){

}

