/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// Border.cpp: implementation of the Border class.
//
//////////////////////////////////////////////////////////////////////

#include "Border.h"
#include "Simulator.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Border::Border(real x, real y, 
               real normalX, real normalY, std::string label) : 
    PhysicalObject(label)
{
	r.x=x;
	r.y=y;
	assert(normalX!=0 || normalY!=0);
	normal.x=normalX;
	normal.y=normalY;

	//set up bounding box
	boxMin.x=-ThyrixParameters::infinity;
	boxMax.x=ThyrixParameters::infinity;
	boxMin.y=-ThyrixParameters::infinity;
	boxMax.y=ThyrixParameters::infinity;
	if(normalX==0){
		//border on x direction
		if(normalY>0){
			//bottom border
			boxMax.y=r.y;
		} else {
			//top border
			boxMin.y=r.y;
		}
	}
	if(normalY==0){
		//border on y direction
		if(normalX>0){
			//left border
			boxMax.x=r.x;
		} else {
			//right border
			boxMin.x=r.x;
		}
	}
}

Border::~Border(){
}
