/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// Elastoid.h: interface for the Elastoid class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ELASTOID_H__DCB64B95_CC6D_4280_9E1F_242450B50FAF__INCLUDED_)
#define AFX_ELASTOID_H__DCB64B95_CC6D_4280_9E1F_242450B50FAF__INCLUDED_

#include "ElasticLink.h"

class Elastoid : public PhysicalObject  {
public:
	Elastoid();
	virtual ~Elastoid();

	PhysicalObjectPVector objects;
	ElasticLinkVector links;

	void addObject(PhysicalObject* object){
		objects.push_back(object);
	}

	virtual void registerPrimitives(Simulator* simulator);


	virtual void computeDerivativesWithoutContacts(ContactSolver* contactSolver);
	virtual void computeDerivatives(GlobalContactInfoVector* globalContacts);
	virtual void integrate(const Integrator &integrator);

	virtual bool detectContacts(PhysicalObject* object, GlobalContactInfoVector* contacts);
	virtual void detectInternalContacts(GlobalContactInfoVector* globalContacts);
	virtual void deleteContacts();
	virtual bool detectMouseContact(const Vector2& rMouse, Vector2& p, PhysicalObject*& object);

	virtual void draw(GUI* gui);


};

#endif // !defined(AFX_ELASTOID_H__DCB64B95_CC6D_4280_9E1F_242450B50FAF__INCLUDED_)
